<template>
  <box>
    <template v-slot:title>
      {{ capitalizeFirstLetter(action) }} Cors Origin
    </template>

    <div class="px-3 w-full flex flex-row">
      <lull-input
        class="w-full"
        label="Origin:"
        v-model="local.origin"
        :class="[hasError('origin') && 'shake']"
        :message="getValidationMessage('origin')"
        :status="getValidationStatus('origin')"
      />
    </div>

    <div class="flex flex-row w-full justify-end pt-5">
      <lull-button type="danger" @click="cancel()">Cancel</lull-button>
      <lull-button class="ml-3" type="info" @click="save()">Save</lull-button>
    </div>
  </box>
</template>

<script lang="ts">
import { defineComponent, onMounted, onUpdated, PropType, reactive } from 'vue';
import { useStore } from '@/store';
import { ManageAction } from '@/core/types/ManageAction';
import { ClientAction } from '@/store/Clients/ClientModule';
import { ClientCorsOrigin } from '@/core/models/client/ClientCorsOrigin';
import { required, url } from '@vuelidate/validators';
import useValidation from '@/core/composables/useValidations';
import { capitalizeFirstLetter } from '@/core/helpers/util';

export default defineComponent({
  name: 'corsorigin',
  emits: ['close', 'refresh'],
  props: {
    action: { type: String, required: false, default: ManageAction.Create },
    clientId: { type: String, required: true },
    origin: {
      type: Object as PropType<ClientCorsOrigin>,
      required: false,
      default: () => ({}),
    },
  },
  setup(props, { emit }) {
    const store = useStore();
    const local: Partial<ClientCorsOrigin> = reactive({});

    const rules = {
      origin: { required, url },
    };

    const {
      validation,
      getValidationMessage,
      getValidationStatus,
      hasError,
    } = useValidation(rules, local, { $stopPropagation: true });

    function cancel(): void {
      validation.value.$reset();
      emit('close');
    }

    async function save(): Promise<void> {
      validation.value.$touch();
      if (validation.value.$invalid) {
        return;
      }

      const action =
        props.action === ManageAction.Create
          ? `client/${ClientAction.AddCorsOrigin}`
          : `client/${ClientAction.UpdateCorsOrigin}`;

      const results = await store.dispatch(action, {
        clientId: props.clientId,
        origin: local,
      });

      if (results) {
        validation.value.$reset();
        emit('refresh');
      }
    }

    onMounted(() => {
      if (props.origin) {
        Object.assign(local, props.origin);
      }
    });

    onUpdated(() => {
      if (props.origin) {
        Object.assign(local, props.origin);
      }
    });

    return {
      local,
      cancel,
      save,
      validation,
      capitalizeFirstLetter,
      getValidationMessage,
      getValidationStatus,
      hasError,
    };
  },
});
</script>